// Global objects
//-----------------------------------------
SamplerState samLinear
{
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = Clamp;
    AddressV = Clamp;
    AddressW = Clamp;
};

RasterizerState cullBack
{
	CullMode = Back;
};

BlendState SrcAlphaBlendingAdd
{
    BlendEnable[0] = TRUE;
    SrcBlend = SRC_ALPHA;
    DestBlend = INV_SRC_ALPHA;
    BlendOp = ADD;
};


matrix Projection;
matrix View;
matrix World;
float blendVal;
float tex1, tex2;

//-----------------------------------------

Texture2DArray txFlames;

struct PS_INPUT_CAST
{
    float4 Pos : SV_POSITION;
    float2 Tex : TEXCOORD0;
};

PS_INPUT_CAST VSFlames(float4 pos : POSITION)
{
    PS_INPUT_CAST output;
    
    float4 pos2 = pos;
    pos2.y *= 5.4;
    pos2.xy *= 2.2;
    pos2.xyz += mul(World[3].xyzw, View).xyz;
    pos2 = mul(pos2, Projection);
    
    output.Pos = pos2;
    output.Tex = pos / 2 + 0.5;  // Convert [-1 1] to [0 1]
    output.Tex.y = 1.0f - output.Tex.y;
    return output;
}

float4 PSFlames(PS_INPUT_CAST input) : SV_Target
{      
    float4 col1 = txFlames.Sample(samLinear, float3(input.Tex.xy, tex1));
    float4 col2 = txFlames.Sample(samLinear, float3(input.Tex.xy, tex2));
    float4 col = lerp(col1, col2, blendVal);
    col.xyz *= 13;
    return col;
}

//-----------------------------------------

technique10 Render
{
    pass P0
    {
        SetRasterizerState(cullBack);
        SetVertexShader(CompileShader(vs_4_0, VSFlames()));
        SetGeometryShader(NULL);
        SetPixelShader(CompileShader(ps_4_0, PSFlames()));
        SetBlendState(SrcAlphaBlendingAdd, float4( 0.0f, 0.0f, 0.0f, 0.0f ), 0xFFFFFFFF);
    }
}