matrix World;
matrix View;
matrix Projection;
float4 Color;
TextureCube EnvironmentMap;


struct VS_INPUT
{
    float4 Pos : POSITION;
};

struct PS_INPUT
{
    float4 Pos : SV_POSITION;
    float3 SpherePos : TEXCOORD0;
};

SamplerState SamLinear
{
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = Clamp;
    AddressV = Clamp;
    AddressW = Clamp;
};

//--------------------------------------------------------------------------------------

PS_INPUT VSDebugSphere(VS_INPUT input)
{
    PS_INPUT output;
    output.SpherePos = input.Pos.xyz;
    output.Pos = mul(input.Pos, mul(mul(World, View),Projection));
    
    return output;
}

float4 PSDebugSphere(PS_INPUT input) : SV_Target
{
	return Color;
}

float4 PSDebugSphereEnvironmentMap(PS_INPUT input) : SV_Target
{
	return EnvironmentMap.Sample(SamLinear, input.SpherePos);
}

technique10 RenderDebugSphere
{
    pass P0
    {
        SetVertexShader(CompileShader(vs_4_0, VSDebugSphere()));
        SetGeometryShader(NULL);
        SetPixelShader(CompileShader(ps_4_0, PSDebugSphere()));
    }
}

technique10 RenderDebugSphereEnvironmentMap
{
    pass P0
    {
        SetVertexShader(CompileShader(vs_4_0, VSDebugSphere()));
        SetGeometryShader(NULL);
        SetPixelShader(CompileShader(ps_4_0, PSDebugSphereEnvironmentMap()));
    }
}